<?php
// members main page
$page['header'] = LBL_MEMBERS;
$page['javascript'] = "<script src='javascript/actions.js' type='text/javascript'></script>\n";
$page['javascript'] .= "<script src='javascript/members.js' type='text/javascript'></script>\n";
$page['crumbs'][] = 'teams';
$page['content'] = '';

$actions['leave']['show'] = true;
$actions['leave']['enabled'] = true;
$actions['invite']['show'] = true;
$actions['remove']['show'] = true;

//$page['content'] .= "<pre>" . print_r($_POST, true) . "</pre>\n";

$group_id = array_key_exists('group_id', $_POST) ? $_POST['group_id'] : NULL;
$control = array_key_exists('control', $_POST) ? $_POST['control'] : NULL;
$new_roles = array_key_exists('roles', $_POST) ? $_POST['roles'] : NULL;;
$new_removes = array_key_exists('removes', $_POST) ? $_POST['removes'] : NULL;;
$new_del_requests = array_key_exists('del_requests', $_POST) ? $_POST['del_requests'] : NULL;;
$new_add_requests = array_key_exists('add_requests', $_POST) ? $_POST['add_requests'] : NULL;

$gr = new_grouper();
if (!$gr->isConnected()) {
  $page['errors'][] = ERROR_GROUPER_CONNECT;
  return;
}
if (!source_connect($ldap) || !$ldap['bind']) {
  $page['errors'][] = ERROR_SOURCE_CONNECT;
  return;
}
if (!db_connect($db)) {
  $page['errors'][] = ERROR_DB_CONNECT;
  return;
}

$group = $gr->getGroup($group_id);
$members = $gr->getGroupMembers($group_id);
$privs = $gr->getGroupPrivileges($group_id);
$self_privs = privileges2role($privs[$uuid]);
if ($self_privs == 3) $actions['leave']['enabled'] = false;
if ($self_privs < 2) $actions['invite']['enabled'] = false;
$page['actions'] = show_actions($actions);

if ($control == LBL_MEMBERS_FORM_ACTION) {
  // Handle privileges2role
  if (isset($new_roles)) foreach ($new_roles as $member_id => $rolenr) {
    if ($rolenr == 1 && $self_privs >= 1) {
      $set_adminpriv = $gr->setPrivilege($group_id, $member_id, 'admin', FALSE);
      $set_updatepriv = $gr->setPrivilege($group_id, $member_id, 'update', FALSE);
      $set_readpriv = $gr->setPrivilege($group_id, $member_id, 'read', TRUE);
      $set_optoutpriv = $gr->setPrivilege($group_id, $member_id, 'optout', TRUE);
      //$privs[$member_id] = array('optout', 'read');
    }
    if ($rolenr == 2 && $self_privs >= 2) {
      $set_adminpriv = $gr->setPrivilege($group_id, $member_id, 'admin', FALSE);
      $set_updatepriv = $gr->setPrivilege($group_id, $member_id, 'update', TRUE);
      $set_readpriv = $gr->setPrivilege($group_id, $member_id, 'read', TRUE);
      $set_optoutpriv = $gr->setPrivilege($group_id, $member_id, 'optout', TRUE);
      //$privs[$member_id] = array('optout', 'read', 'update');
    }
    if ($rolenr == 3 && $self_privs >= 3) {
      $set_adminpriv = $gr->setPrivilege($group_id, $member_id, 'admin', TRUE);
      $set_updatepriv = $gr->setPrivilege($group_id, $member_id, 'update', TRUE);
      $set_readpriv = $gr->setPrivilege($group_id, $member_id, 'read', TRUE);
      $set_optoutpriv = $gr->setPrivilege($group_id, $member_id, 'optout', TRUE);
      //$privs[$member_id] = array('optout', 'read', 'update', 'admin');
    }
  }

  // Handle request deletes
  if (isset($new_del_requests)) foreach($new_del_requests as $key => $remove) {
    if (!delete_request($db, $remove, $group_id)) {
      $page['errors'][] = ERROR_DELETE_REQUEST;
    }
  }

  // Handle member deletes (by removebox).
/*
  if (isset($new_removes)) {
    foreach($new_removes as $remove) {
      if (!($remove == $uuid && $self_privs == 3)) {
	if (!$gr->deleteMember($remove, $group_id)) {
	  $page['errors'][] = ERROR_GROUPER_DELETEMEMBER;
	}
      }
    }
    $members = $gr->getGroupMembers($group_id);
  }
*/
  if (isset($new_removes)) {
    $page['messages'][] = LBL_MEMBERS_NODELETEBYCHECKOX;
  }

  // Handle member deletes (by unchecked memberbox).
  if (is_array($members)) foreach($members as $id => $member) {
    if (!isset($new_roles[$member['id']]) && privileges2role($privs[$member['id']]) < 3) {
      $gr->setPrivilege($group_id, $member['id'], 'optout', false);
      $gr->setPrivilege($group_id, $member['id'], 'read', false);
      $gr->setPrivilege($group_id, $member['id'], 'update', false);
      $gr->setPrivilege($group_id, $member['id'], 'admin', false);
      if (!$gr->deleteMember($member['id'], $group_id)) {
	$page['errors'][] = ERROR_GROUPER_DELETEMEMBER;
      } else {
	//unset($members[$id]);
      }
    }
  }


  // Handle invitations
  if (isset($new_add_requests) && $self_privs >= 2) {
    foreach ($new_add_requests as $requestor) {
      if (!$gr->addMember($group_id, $requestor, $uuid)) {
	$page['errors'][] = ERROR_GROUPER_ADDMEMBER;
	return;
      }
      $set_readpriv = $gr->setPrivilege($group_id, $requestor, 'read', TRUE);
      $set_optoutpriv = $gr->setPrivilege($group_id, $requestor, 'optout', TRUE);
      if (!$set_readpriv || !$set_optoutpriv) {
	$page['errors'][] = ERROR_GROUPER_SETPRIVILEGES;
	return;
      }
      if (!delete_request($db, $requestor, $group_id)) {
	$page['errors'][] = ERROR_DELETE_REQUEST;
	return;
      }
    }
  }

  $privs = $gr->getGroupPrivileges($group_id);
  $members = $gr->getGroupMembers($group_id);
}

$page['content'] .= "<h1>" . $group['name'] . "</h1>\n";
$page['content'] .= LBL_MEMBERS_CONTENT . "<br><br>\n";
//$page['content'] .= "self privs: " . privileges2role($privs[$uuid]) . "<br>\n";

$page['content'] .= "<form method='post' name='teamlist' action=''>\n";
$page['content'] .= "<input type=hidden name='group_id' value='" . $group['id'] . "'>";

//$page['content'] .= "<h2>Members</h2>\n";

$page['content'] .= "<table class='alternating'>\n";
$page['content'] .= "<tr><td colspan='2'></td><td colspan='3'>" . LBL_MEMBERS_ROLES . "</td></tr>\n";
$page['content'] .= "<tr><td></td><td>" . LBL_MEMBERS_NAME . "</td><td>" . LBL_MEMBERS_ADMIN . "</td><td>" . LBL_MEMBERS_MANAGER . "</td><td>" . LBL_MEMBERS_MEMBER . "</td></tr>\n";

$row = 0;
if (is_array($members)) foreach($members as $id => $member) {
  //$privs = $gr->getSubjectGroupPrivileges($member['id'], $group_id);
  //$page['content'] .= $member['id'] . ": " . privileges2role($privs) . "<br>\n";
  $member_privs = privileges2role($privs[$member['id']]);
  if (!$profile = source_profile($ldap, $member['id'])) {
    $page['errors'][] = ERROR_SOURCE_PROFILE;
  }

  // Headache!!
  $its_me = ($member['id'] == $uuid);
  $im_admin = ($self_privs == 3);
  $im_manager = ($self_privs >= 2);
  $im_more_equal = ($self_privs >= $member_privs);
  $blocked = ($its_me && $im_admin);
  $can_remove = ($im_manager && $im_more_equal) && !($blocked) ;

  $page['content'] .= "<tr" . ($row++%2?"":" class='even'") . ">\n";
  $page['content'] .= "<td>" . ($can_remove?"<input type='checkbox' name='removes[]' value='" . $member['id'] . "' onclick='toggle_remove();'>":"") . "</td>\n";
  $page['content'] .= "<td " . ($blocked?"style='color:red'":"") . ">" . $profile['cn'][0] . "</td>\n";
  $page['content'] .= "<td><input type='checkbox' id='roles[" . $member['id'] . "]-3' name='roles[" . $member['id'] . "]' value='3' onclick='update_roles(this);'" . ($member_privs == 3?" checked":"") . (($self_privs < 3 || $member['id'] == $uuid)?" disabled":"") . "></td>\n";
  $page['content'] .= "<td><input type='checkbox' id='roles[" . $member['id'] . "]-2' name='roles[" . $member['id'] . "]' value='2' onclick='update_roles(this);'" . ($member_privs >= 2?" checked":"") . (($member_privs > 2 || $self_privs < 2)?" disabled":"") . "></td>\n";
#  $page['content'] .= "<td><input type='checkbox' id='roles[" . $member['id'] . "]-1' name='roles[" . $member['id'] . "]' value='1' onclick='update_roles(this);'" . ($member_privs >= 1?" checked":"") . (($member_privs > 1 || $self_privs < 1)?" disabled":"") . "></td>\n";
  $page['content'] .= "<td><input type='checkbox' id='roles[" . $member['id'] . "]-1' name='roles[" . $member['id'] . "]' value='1' checked disabled></td>\n";
  $page['content'] .= "</tr>\n";
}

$page['content'] .= "<tr style='height: 10px;'></tr>\n";


// Requests
$requests = get_requests($db, $group_id);
if ($requests == -1) {
  $page['errors'][] = ERROR_DB_SELECT;
} else {
  if (is_array($requests)) foreach($requests as $id => $request) {
    if (!$profile = source_profile($ldap, $request['uuid'])) {
      $page['errors'][] = ERROR_SOURCE_PROFILE;
    }
    //$page['content'] .= $invitation['mailaddress'] . "<br>\n";
    $page['content'] .= "<tr>\n";
    $page['content'] .= "<td>" . ($self_privs >= 2?"<input type='checkbox' name='del_requests[]' value='" . $request['uuid'] . "' onclick='toggle_remove();'>":"") . "</td>\n";
    $page['content'] .= "<td>" . $profile['cn'][0] . "</td>\n";
    $page['content'] .= "<td colspan='2'>" . LBL_MEMBERS_REQUESTED . "</td>\n";
    $page['content'] .= "<td><input type='checkbox' name='add_requests[]' value='" . $request['uuid'] . "'> " . LBL_MEMBERS_ADDMEMBER . "</td>\n";
    $page['content'] .= "</tr>\n";
  }
}

// Invitations

$invitations = get_invitations($db, $group_id);
if ($invitations == -1) {
  $page['errors'][] = ERROR_DB_SELECT;
} else {
  if (is_array($invitations)) foreach($invitations as $id => $invitation) {
    //$page['content'] .= $invitation['mailaddress'] . "<br>\n";
    $page['content'] .= "<tr>\n";
    $page['content'] .= "<td></td>\n";
    $page['content'] .= "<td>" . $invitation['mailaddress'] . "</td>\n";
    $page['content'] .= "<td colspan='3'>" . ($invitation['denied'] == 't' ?LBL_MEMBERS_DENIED:LBL_MEMBERS_INVITED) . "</td>\n";
    $page['content'] .= "</tr>\n";
  }
}


$page['content'] .= "</table>\n";

$page['content'] .= "<br><input type='submit' name='control' value='" . LBL_MEMBERS_FORM_ACTION . "'>\n";
$page['content'] .= "</form>\n";


?>
